using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Xamarin.Forms;
using Syncfusion.SfChart.XForms.Droid;
using Com.Syncfusion.Charts;
using Java.Util;


[assembly: ExportRenderer(typeof(SimpleSample.CustomChart), typeof(SimpleSample.Droid.CustomRenderer))]

namespace SimpleSample.Droid
{
    class CustomRenderer : SfChartRenderer
    {
        CustomChart chart;
        protected override void OnElementChanged(Xamarin.Forms.Platform.Android.ElementChangedEventArgs<Syncfusion.SfChart.XForms.SfChart> e)
        {
            base.OnElementChanged(e);
            chart = e.NewElement as CustomChart;
            var nativeControl = Control;
            nativeControl.Series.Clear();
            var lineSeries = new NativeChartSeriesExt();
            nativeControl.Series.Add(lineSeries);
            var properties = GetPublicProperties(chart.Series[0].GetType());

            foreach (var name in properties)
            {
                ChartSeriesMapping.OnLineSeriesPropertiesChanged(name, (Syncfusion.SfChart.XForms.LineSeries)chart.Series[0], lineSeries);
            }

            nativeControl.RedrawChart();
        }

        internal static IEnumerable<String> GetPublicProperties(Type type)
        {
            Dictionary<Type, IEnumerable<string>> properties = new Dictionary<Type, IEnumerable<string>>();
            if (properties != null && properties.ContainsKey(type))
            {
                return properties[type];
            }
            var collection = type.GetProperties().Where(property =>
                property.DeclaringType.Namespace.Contains("Syncfusion.SfChart.XForms")
                && property.SetMethod.IsPublic).Select(s => s.Name);
            if (properties != null)
                properties.Add(type, collection);
            return collection;
        }
    }

    public class NativeChartSeriesExt : Com.Syncfusion.Charts.LineSeries
    {

        public NativeChartSeriesExt()
        {

        }

        protected override void DrawDataMarker(int p0, Android.Graphics.Canvas p1, Android.Graphics.Paint p2, Android.Graphics.Paint p3, float p4, float p5)
        {
            var arrayList = DataSource as ObservableArrayList;

            string d = (arrayList.Get(p0) as ChartDataPoint).GetY().ToString();
            if (Double.Parse(d) < 22)
                p2.Color = Android.Graphics.Color.LightBlue;
            else
                if (Double.Parse(d) >= 22 && Double.Parse(d) < 34)
                    p2.Color = Android.Graphics.Color.Yellow;
                else
                    p2.Color = Android.Graphics.Color.Cyan;
            base.DrawDataMarker(p0, p1, p2, p3, p4, p5);
        }
    }
}