﻿using Syncfusion.SfChart.XForms;
using Syncfusion.SfChart.XForms.WinPhone;
using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Markup;
using System.Windows.Media;
using Xamarin.Forms;

[assembly: ExportRenderer(typeof(SimpleSample.CustomChart), typeof(SimpleSample.WinPhone.CustomRenderer))]
namespace SimpleSample.WinPhone
{
    public class TooltipConverter : DependencyObject, System.Windows.Data.IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null)
                return String.Empty;

            double data = System.Convert.ToDouble(value.ToString());

            if (data < 22)
                return "Green";
            else if (data <= 34 && data > 22)
                return "Orange";
            else if (data > 34)
                return "Red";
            else
                return "Transparent";
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }

    }


    class CustomRenderer : SfChartRenderer
    {
        private CustomChart formChart;
      
        protected override void OnElementChanged(Xamarin.Forms.Platform.WinPhone.ElementChangedEventArgs<Syncfusion.SfChart.XForms.SfChart> e)
        {
            base.OnElementChanged(e);
            formChart = e.NewElement as CustomChart;

            foreach (var item in Control.Series)
            {
                item.ShowTooltip = true;
                ChartAdornmentInfo adorn = new ChartAdornmentInfo();
                adorn.ShowLabel = true;

                StringBuilder stringBuilder = new StringBuilder();

                stringBuilder.Clear();
                stringBuilder.Append("<DataTemplate xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\" ");
                stringBuilder.Append(" xmlns:x=\"http://schemas.microsoft.com/winfx/2006/xaml\"");
                stringBuilder.Append(" xmlns:labelConverter=\"clr-namespace:SimpleSample.WinPhone;assembly=SimpleSample.WinPhone\">");
                stringBuilder.Append("<Border>");
                stringBuilder.Append("<Border.Resources>");
                stringBuilder.Append("<labelConverter:TooltipConverter  x:Key=\"tooltip\"/>");
                stringBuilder.Append("</Border.Resources>");
                stringBuilder.Append("<Ellipse Width='20' Height='20' Fill=\"{Binding Converter={StaticResource tooltip}, ConverterParameter={StaticResource tooltip}}\"  />");
                stringBuilder.Append("</Border></DataTemplate>");
                adorn.LabelTemplate = (System.Windows.DataTemplate)XamlReader.Load(stringBuilder.ToString());
                (item as AdornmentSeries).AdornmentsInfo = adorn;
            }
        }
    }

}
