﻿using System;
using Syncfusion.SfChart.iOS;
using UIKit;
using CoreGraphics;
using Foundation;

namespace SimpleSample
{
	public class CustomLineSeries : SFLineSeries
	{
		private CustomChartDataMarker customDataMarker;
		public CustomLineSeries ()
		{
			customDataMarker = new CustomChartDataMarker (this);
		}
			
		public override SFChartDataMarker DataMarker {
			get {
				return customDataMarker;
			}
		}
	}

	public class CustomChartDataMarker : SFChartDataMarker
	{
		public SFSeries CustomSeries {
			get;
			set;
		}

		public CustomChartDataMarker (SFSeries series):base(series)
		{
			CustomSeries = series;
		}

		public override void DrawMarker (CGContext ctx, CGRect rect)
		{
			CGPoint location = new CGPoint (rect.X + CustomSeries.LayerFrame.X,rect.Y + CustomSeries.LayerFrame.Y);
			SFChartDataPoint datapoint = (CustomSeries as SFCartesianSeries).FindNearestDataPoint (location);

			if (datapoint != null) {
				if (datapoint.YValue is NSNumber) {
					NSNumber x = (NSNumber)datapoint.YValue;
					if (x.DoubleValue < 22)
						this.MarkerColor = UIColor.Green;
					else if (x.DoubleValue <= 34 && x.DoubleValue > 22)
						this.MarkerColor = UIColor.Orange;
					else if (x.DoubleValue > 34)
						this.MarkerColor = UIColor.Red;
				}
			}

			base.DrawMarker (ctx, rect);
		}
	
	}
}
