﻿using System;
using Xamarin.Forms;
using SimpleSample;
using SimpleSample.iOS;
using Syncfusion.SfChart.XForms.iOS.Renderers;
using Syncfusion.SfChart.XForms;
using Syncfusion.SfChart.iOS;
using Syncfusion.SfChart.XForms.iOS;
using System.Collections.Generic;

[assembly: ExportRenderer(typeof(CustomChart), typeof(CustomRenderer))]
namespace SimpleSample.iOS
{
	public class CustomRenderer:SfChartRenderer
	{
		private CustomChart formChart;
		public CustomRenderer()
		{

		}

		protected override void OnElementChanged (Xamarin.Forms.Platform.iOS.ElementChangedEventArgs<SfChart> e)
		{
			base.OnElementChanged (e);
			formChart = e.NewElement as CustomChart;
			Control.DataSource = new CustomDatasource (formChart.Series,Control,formChart);
		}
			
	}

	public class CustomDatasource: ChartDataSource
	{

		public CustomDatasource(ChartSeriesCollection series, SFChart nativeChart, SfChart formsChart):base(series,nativeChart,formsChart)
		{

		}

		public override SFSeries GetSeries (SFChart chart, nint index)
		{
			ChartSeries chartSeries = this.Series [(int)index] as ChartSeries;
			var nativeSeries = SfChartRenderer.GetNativeObject(typeof(ChartSeries)
				, chartSeries) as SFSeries;

			if (chartSeries is LineSeries) {

				CustomLineSeries lineSeries = new CustomLineSeries();

				List<string> properties = SfChartRenderer.GetPropertiesChanged(typeof(ChartSeries), chartSeries);

				foreach (var name in properties)
				{
					ChartSeriesMapping.OnLineSeriesPropertiesChanged(name, (LineSeries)chartSeries, lineSeries);
				}

				nativeSeries = lineSeries;

				return nativeSeries;

			}
			else
				return ChartSeriesMapping.GetNativeSeries(chartSeries);
		}
			
	}
}
	
	

