﻿using System;

using Xamarin.Forms;
using Syncfusion.SfChart.XForms;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Threading.Tasks;

namespace SimpleSample
{
	public class Line : ContentPage
	{
		AbsoluteLayout layout;
		CustomChart chart;
		ObservableCollection<ChartDataPoint> Data ;

		public Line ()
		{			
		   Data   = new ObservableCollection<ChartDataPoint>();
		   layout = new AbsoluteLayout(){Padding = new Thickness(5,15,5,5)};

			Data.Add(new ChartDataPoint(new DateTime(2002,6,1), 23));
			Data.Add(new ChartDataPoint(new DateTime(2002,6,2), 20));
			Data.Add(new ChartDataPoint(new DateTime(2002,6,3), 35));
			Data.Add(new ChartDataPoint(new DateTime(2002,6,4), 32));
			Data.Add(new ChartDataPoint(new DateTime(2002,6,5), 45));
			Data.Add(new ChartDataPoint(new DateTime(2002,6,6), 10));
			Data.Add(new ChartDataPoint(new DateTime(2002,6,7), 20));
			Data.Add(new ChartDataPoint(new DateTime(2002,6,8), 35));
			Data.Add(new ChartDataPoint(new DateTime(2002,6,9), 32));
			Data.Add(new ChartDataPoint(new DateTime(2002,6,10), 25));
			Data.Add(new ChartDataPoint(new DateTime(2002,6,11),38));

			chart = new CustomChart ();
			CategoryAxis cataxis = new CategoryAxis()
			{
				Interval = 1,
			};
			chart.PrimaryAxis = cataxis;

			NumericalAxis numaxis = new NumericalAxis ();
			chart.SecondaryAxis = numaxis;

			NumericalStripLine strip1 = new NumericalStripLine ();
			strip1.Start = 22;
			strip1.Width = -7;
			strip1.FillColor = Color.Green;
			strip1.IsPixelWidth = true;
			strip1.Text = "Low Temperature";
			strip1.LabelStyle.TextColor = Color.White;

			NumericalStripLine strip2 = new NumericalStripLine ();
			strip2.Start = 34;
			strip2.Width = -7;
			strip2.FillColor = Color.Pink;
			strip2.IsPixelWidth = true;
			strip2.Text = "Middle Temperature";
			strip2.LabelStyle.TextColor = Color.White;

			NumericalStripLine strip3 = new NumericalStripLine ();
			strip3.Start = 46;
			strip3.Width = -7;
			strip3.FillColor = Color.Red;
			strip3.IsPixelWidth = true;
			strip3.Text = "High Temperature";
			strip3.LabelStyle.TextColor = Color.White;

			numaxis.StripLines.Add (strip1);
			numaxis.StripLines.Add (strip2);
			numaxis.StripLines.Add (strip3);

			chart.ChartBehaviors.Add (new ChartZoomPanBehavior());

			var line = new LineSeries { 
				ItemsSource = Data,

			};

			chart.VerticalOptions = LayoutOptions.FillAndExpand;

            line.DataMarker = new ChartDataMarker();
            line.DataMarker.ShowMarker = true;
			chart.Series.Add(line);
			layout.Children.Add(chart);

			Content = layout;
		}


	} 

}


